/*
   Reading from /dev/urandom

   Build: make a_urandom (or g++ t_urandom.cpp -pthread -lwy -lpthread)
*/
#include "../src/wychrfile.h"
#include "../src/wy_uty.h"

static const WyCSeg DevName("/dev/urandom");

static const WyStr chdr(
                  "+------------------+\n"
                  "| main(..) caught: |\n"
                  "+------------------+\n");
int main(void) throw()
try {
 WyChrFile mh(DevName,O_RDONLY);

 for(int i=0; i<20; ++i) {

   // read 1 character
   //
   unsigned char vaa;
   mh >> vaa;
   Wy::cout << vaa << ' ';

   // read sizeof(uint) characters
   //
   unsigned int vbb;
   size_t n_rd;
   WyRet r;
   if((r=mh._xread(&vbb,sizeof(vbb),n_rd))!=OK) {
     WY_THROW( WyByteFlow::Reply(r) );
   }
   Wy::cout << vbb << ' ';
 }

 Wy::cout << "\nOK\n";
 return(0);
}
catch(const WyRet& e) {
 if(e!=OK) {
   Wy::cerr << chdr << Wy::wrd(e) << '\n';
 }
 return e->c_repcode();
}
catch(...) {
 Wy::cerr << chdr << "unknown thrown type\n";
 return(-1);
};
