/* Copyright is licensed under GNU LGPL.                 by I.J.Wang 2003

   Build: make demo_reply
*/
#include "../src/wystr.h"
#include "../src/wybyteflow.h"
#include "../src/wy_uty.h"

// Define application reply for demo
//
class T_RepInfo : public Wy_RepInfo {
  public:
    T_RepInfo(const char* cstr) : Wy_RepInfo(cstr) WY__NOTHROW__ {};
    T_RepInfo(int ec, const char* cstr) : Wy_RepInfo(ec,cstr) WY__NOTHROW__ {};
    size_t get_reply(char* buf, size_t blen) const WY__NOTHROW__
        { return Wy_RepInfo::get_reply(buf,blen); };
    void set_reply(const char* str, size_t slen) WY__NOTHROW__
        {};  // no effect
};
static T_RepInfo ei("User defined reply E001");
const static WyReply E001(ei);

int main(void)
try {

 // Print errno 0-127
 //
 for(int i=0; i<=Wy::_max_errno; ++i) {
   WyReply ei(i);
   Wy::cerr << i << "  " << Wy::wrd(ei) << '\n';
 }

 // Print the libwy added reply's
 //
 Wy::cout << "\nWym_ETHRDCAN " << Wy::wrd(Wym_ETHRDCAN);
 Wy::cout << "\nWym_EDIVZERO " << Wy::wrd(Wym_EDIVZERO);
 Wy::cout << "\nWym_EMATHNEG " << Wy::wrd(Wym_EMATHNEG);
 Wy::cout << "\nWym_EBADTYPE " << Wy::wrd(Wym_EBADTYPE);
 Wy::cout << "\n";

 // Print the note
 //
 Wy::cerr << "\n -- Note --\n";
 Wy::cerr << "E001=" << Wy::wrd(E001) << '\n';
 Wy::cerr << "WyReply()=" << Wy::wrd(WyReply()) << '\n';
 Wy::cerr << "WyReply(0)=OK=" << Wy::wrd(OK) << '\n';
 Wy::cerr << "OK=" << Wy::wrd(OK) << '\n';

 return(0);
}
catch(const WyRet& e) {
 Wy::cerr << Wy::wrd(e) << '\n';
 return(-1);
}
catch(...) {
 Wy::cerr << "main() caught(...)\n";
 return(-1);
};
