/* Copyright is licensed under GNU LGPL.                 by I.J.Wang 2005

   Check functions in wy_uty.h

   Build: chk_uty
*/

#include "wyret.h"
#include "wy_uty.h"
#include <iostream>   // for std::cerr/cout

#if WY_UTY_VERSION!=30
#error Test code is for WY_UTY_VERSION 30
#endif

extern void ck_uty(void);

static const WyStr chdr(
                  "+---------------+\n"
                  "| main() caught:|\n"
                  "+---------------+\n");
int main(void) throw()
try {
 std::cout << "Checking wy_uty.cpp...\n";
 ck_uty();
 std::cout << "Checked OK\n";
 return(0);
}
catch(const WyRet& e) {
 std::cerr << chdr.c_str() << Wy::wrd(e).c_str() << std::endl;
 return(-1);
}
catch(...) {
 std::cerr << chdr.c_str() << "unknown unwind type\n";
 return(-1);
};
